//
// NB! This is a file generated from the .4Dino file, changes will be lost
//     the next time the .4Dino file is built
//
#define RESETLINE     30

#define DisplaySerial Serial1

// uncomment to log SPE errors messages to Serial (serial monitor)
#define LOG_MESSAGES

#include "Picaso_Serial_4DLib.h"
#include "Picaso_Const4D.h"

Picaso_Serial_4DLib Display(&DisplaySerial);
int intensity ;
int led_pin;

// routine to handle Serial errors
void mycallback(int ErrCode, unsigned char Errorbyte)
{
#ifdef LOG_MESSAGES
  const char *Error4DText[] = {"OK\0", "Timeout\0", "NAK\0", "Length\0", "Invalid\0"} ;
  LOG_MESSAGES.print(F("Serial 4D Library reports error ")) ;
  LOG_MESSAGES.print(Error4DText[ErrCode]) ;
  if (ErrCode == Err4D_NAK)
  {
    LOG_MESSAGES.print(F(" returned data= ")) ;
    LOG_MESSAGES.println(Errorbyte) ;
  }
  else
    LOG_MESSAGES.println(F("")) ;
  while (1) ; // you can return here, or you can loop
#else
  // Pin 13 has an LED connected on most Arduino boards. Just give it a name
#define led 13
  while (1)
  {
    digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
    delay(200);                // wait for a second
    digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
    delay(200);                // wait for a second
  }
#endif
}
// end of routine to handle Serial errors


void setup()
{

  pinMode(RESETLINE, OUTPUT);       // Display reset pin
digitalWrite(RESETLINE, 1);       // Reset Display, using shield
  delay(100);                       // wait for it to be recognised
digitalWrite(RESETLINE, 0);       // Release Display Reset, using shield
  delay(4000) ;                     // give display time to startup

  DisplaySerial.begin(200000) ;     // Hardware serial to Display, same as SPE on display is set to
  Display.TimeLimit4D = 5000 ;       // 5 second timeout on all commands
  Display.Callback4D = mycallback ;
  Display.gfx_ScreenMode(PORTRAIT) ; // change manually if orientation change
  // put your setup code here, to run once:

  led_pin = 13 ;   // Using the On board LED connected to pin D13

  Display.touch_Set(TOUCH_ENABLE);   // enable the touch screen
  Display.gfx_Cls();   // clear screen
  intensity = 0 ;     // initial intensity is set to 0

  Display.gfx_Set(OBJECT_COLOUR, WHITE);
  Display.gfx_Slider(SLIDER_RAISED, 28, 28, 203, 63, TURQUOISE, 100, 0) ;


  Display.txt_Height(2);
  Display.txt_Width(2);
  Display.gfx_MoveTo(25,100) ;
  Display.putstr("Level : 000");       // initializing Level to 0

}

void loop()
{
  byte state ;
  word x, y ;
  char intensity_char[20] ;
  state = Display.touch_Get(TOUCH_STATUS);               // get touchscreen status
  //-----------------------------------------------------------------------------------------
  if((state == TOUCH_PRESSED) || (state == TOUCH_MOVING))  // if there's a press, or it's moving
  {
    x = Display.touch_Get(TOUCH_GETX);
    y = Display.touch_Get(TOUCH_GETY);
    if((y >= 28) && (y <= 63))  // If the slider is touched
    {
      intensity = Display.gfx_Slider(SLIDER_RAISED, 28, 28, 203, 63, TURQUOISE, 100, -x) ;  // use slider to scale x to n
      Display.gfx_MoveTo(25,100) ;
      sprintf(intensity_char,"%3.3d", intensity) ;
      Display.putstr("Level : ") ;

      Display.putstr(intensity_char) ;
      Display.println(intensity);
      Display.print(x);


      analogWrite(led_pin,intensity);  // set the brightness of the LED accordingly
    }
  }
}

